<?php

/*
 * PLUGINOPTIONCREATOR ver.0.3
 * ץ饰󥪥ץô
 * typo
 * Ψ
 */


class SHAREDLIBS_NKJG_PLUGINOPTIONCREATOR {
  var $plugin;

  function SHAREDLIBS_NKJG_PLUGINOPTIONCREATOR(&$plugin) {
    $this->plugin = $plugin;
  }
  
  // Global
  function createGlobalOption_YesNo($name, $desc, $default = 'no') {
    $this->plugin->createOption($name, $desc, 'yesno', $default);
  }

  function createGlobalOption_Text($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createOption($name, $desc, 'text', $default, $meta);
  }

  function createGlobalOption_Password($name, $desc, $default = '') {
    $this->plugin->createOption($name, $desc, 'password', $default);
  }

  function createGlobalOption_TextArea($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createOption($name, $desc, 'textarea', $default, $meta);
  }

  function createGlobalOption_Select($name, $desc, $select, $default = false, $options = false) {
    if (!$default) {
      $default = reset($select);
    }
    $meta = $this->createOptionMetaInformation($options, $select);
    $this->plugin->createOption($name, $desc, 'select', $default, $meta);
  }

  // Blog
  function createBlogOption_YesNo($name, $desc, $default = 'no') {
    $this->plugin->createBlogOption($name, $desc, 'yesno', $default);
  }

  function createBlogOption_Text($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createBlogOption($name, $desc, 'text', $default, $meta);
  }

  function createBlogOption_Password($name, $desc, $default = '') {
    $this->plugin->createBlogOption($name, $desc, 'password', $default);
  }

  function createBlogOption_TextArea($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createBlogOption($name, $desc, 'textarea', $default, $meta);
  }

  function createBlogOption_Select($name, $desc, $select, $default = false, $options = false) {
    if (!$default) {
      $default = reset($select);
    }
    $meta = $this->createOptionMetaInformation($options, $select);
    $this->plugin->createBlogOption($name, $desc, 'select', $default, $meta);
  }
  
  // Category
  function createCategoryOption_YesNo($name, $desc, $default = 'no') {
    $this->plugin->createCategoryOption($name, $desc, 'yesno', $default);
  }

  function createCategoryOption_Text($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createCategoryOption($name, $desc, 'text', $default, $meta);
  }

  function createCategoryOption_Password($name, $desc, $default = '') {
    $this->plugin->createCategoryOption($name, $desc, 'password', $default);
  }

  function createCategoryOption_TextArea($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createCategoryOption($name, $desc, 'textarea', $default, $meta);
  }

  function createCategoryOption_Select($name, $desc, $select, $default = false, $options = false) {
    if (!$default) {
      $default = reset($select);
    }
    $meta = $this->createOptionMetaInformation($options, $select);
    $this->plugin->createCategoryOption($name, $desc, 'select', $default, $meta);
  }
  
  // Member
  function createMemberOption_YesNo($name, $desc, $default = 'no') {
    $this->plugin->createMemberOption($name, $desc, 'yesno', $default);
  }

  function createMemberOption_Text($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createMemberOption($name, $desc, 'text', $default, $meta);
  }

  function createMemberOption_Password($name, $desc, $default = '') {
    $this->plugin->createMemberOption($name, $desc, 'password', $default);
  }

  function createMemberOption_TextArea($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createMemberOption($name, $desc, 'textarea', $default, $meta);
  }

  function createMemberOption_Select($name, $desc, $select, $default = false, $options = false) {
    if (!$default) {
      $default = reset($select);
    }
    $meta = $this->createOptionMetaInformation($options, $select);
    $this->plugin->createMemberOption($name, $desc, 'select', $default, $meta);
  }

  // Item
  function createItemOption_YesNo($name, $desc, $default = 'no') {
    $this->plugin->createItemOption($name, $desc, 'yesno', $default);
  }

  function createItemOption_Text($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createItemOption($name, $desc, 'text', $default, $meta);
  }

  function createItemOption_Password($name, $desc, $default = '') {
    $this->plugin->createItemOption($name, $desc, 'password', $default);
  }

  function createItemOption_TextArea($name, $desc, $default = '', $options = false) {
    $meta = $this->createOptionMetaInformation($options);
    $this->plugin->createItemOption($name, $desc, 'textarea', $default, $meta);
  }

  function createItemOption_Select($name, $desc, $select, $default = false, $options = false) {
    if (!$default) {
      $default = reset($select);
    }
    $meta = $this->createOptionMetaInformation($options, $select);
    $this->plugin->createItemOption($name, $desc, 'select', $default, $meta);
  }

  function createOptionMetaInformation($options = false, $select = false) {
    $aMetaInfo = array();
    if (is_array($select)) {
      $aSelectInfo = array();
      foreach ($select as $key => $value) {
        $aSelectInfo[] = ($key.'|'.$value);
      }
      $aMetaInfo[] = implode('|', $aSelectInfo);
    }
    if (is_array($options)) {
      if (isset($options['numerical'])) {
        if ($options['numerical']) {
          $aMetaInfo[] = 'datatype=numerical';
        }
      }
      if (isset($options['access'])) {
        switch ($options['access']) {
        case 'hidden' :
          $aMetaInfo[] = 'access=hidden';
          break;
        case 'readonly' :
          $aMetaInfo[] = 'access=readonly';
          break;
        }  
      }
    }
    return implode(';', $aMetaInfo);
  }  
}

?>